// JednoduchyEditorDoc.cpp : implementation of the CJednoduchyEditorDoc class
//

#include "stdafx.h"
#include "JednoduchyEditor.h"

#include "JednoduchyEditorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CJednoduchyEditorDoc

IMPLEMENT_DYNCREATE(CJednoduchyEditorDoc, CDocument)

BEGIN_MESSAGE_MAP(CJednoduchyEditorDoc, CDocument)
END_MESSAGE_MAP()


// CJednoduchyEditorDoc construction/destruction

CJednoduchyEditorDoc::CJednoduchyEditorDoc()
{
}

CJednoduchyEditorDoc::~CJednoduchyEditorDoc()
{
}

BOOL CJednoduchyEditorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	//!!! Dokument se znovupouziva, kdyz nekdo da otevrit novy,
	// vsechny linky co mame smazeme, retezec smazeme
	linky.RemoveAll();
	str.Empty();

	return TRUE;
}




// CJednoduchyEditorDoc serialization

void CJednoduchyEditorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{ // ulozeni retezce
		ar << str;
		//!!! zjistime a ulozime si pocet linek, abychom pak pri nacitani vedeli,
		// kolik jich mame nacist
		int pocet_linek = (int)linky.GetSize();
		ar << pocet_linek;
		//!!! a ulozime vsechny linky
		for (int i = 0; i < pocet_linek; i++)
			ar << &linky.GetAt(i);
	}
	else
	{ // nacteme retezec
		ar >> str;

		//!!! nacteme pocet ulozenych linek, abychom vedeli kolikrat nacitat
		int pocet_linek;
		ar >> pocet_linek;

		//!!! a v cyklu vsechny linky nacteme
		for (int i = 0; i < pocet_linek; i++)
		{
			//!!! deklarujeme jen ukazatel, objekt tridy CLinka vytvori MFC! A naplni
			// nam ten ukazatel spravnou hodnotou
			CLinka * pl;
			ar >> pl;
			linky.Add(*pl);
		}
	}
}

void CJednoduchyEditorDoc::AddChar(TCHAR ch)
{
	str = str + ch;
	UpdateAllViews(NULL);
	SetModifiedFlag(TRUE);
}

void CJednoduchyEditorDoc::Backspace()
{
	str.Delete(str.GetLength() - 1, 1);
	UpdateAllViews(NULL);
	SetModifiedFlag(TRUE);
}

CString CJednoduchyEditorDoc::GetString()
{
	return str;
}

const CArray<CLinka, CLinka> * CJednoduchyEditorDoc::GetLines()
{
	//!!! vratime konstantni ukazatel na interni CArray s linkami
	return &linky;
}

void CJednoduchyEditorDoc::AddLine(const CLinka & l)
{
	//!!! pridame linku a nastavime, ze je dokument zmodifikovany a ze je
	// treba prekreslit view
	linky.Add(l);
	UpdateAllViews(NULL);
	SetModifiedFlag(TRUE);
}


// CJednoduchyEditorDoc diagnostics

#ifdef _DEBUG
void CJednoduchyEditorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CJednoduchyEditorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CJednoduchyEditorDoc commands
