// JednoduchyEditorDoc.h : interface of the CJednoduchyEditorDoc class
//
#ifndef _JEDNODUCHY_EDITOR_DOC_H_
#define _JEDNODUCHY_EDITOR_DOC_H_

#pragma once
#include <afxtempl.h>
#include "Clinka.h"

class CJednoduchyEditorDoc : public CDocument
{
protected: // create from serialization only
	CJednoduchyEditorDoc();
	DECLARE_DYNCREATE(CJednoduchyEditorDoc)

// Attributes
public:
	CString str;
	CArray<CLinka, CLinka> linky; //!!!

// Operations
public:
	void AddChar(TCHAR ch);
	void Backspace();
	CString GetString();
	const CArray<CLinka, CLinka> * GetLines(); //!!!
	void AddLine(const CLinka & l); //!!!

// Overrides
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CJednoduchyEditorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};


#endif
