// JednoduchyEditorView.h : interface of the CJednoduchyEditorView class
//
#ifndef _JEDNODUCHY_EDITOR_VIEW_H_
#define _JEDNODUCHY_EDITOR_VIEW_H_

#pragma once
#include "Clinka.h"

class CJednoduchyEditorView : public CView
{
protected: // create from serialization only
	CJednoduchyEditorView();
	DECLARE_DYNCREATE(CJednoduchyEditorView)

// Attributes
private:
	CPoint minulyBod; //!!!
	BOOL minulyBodPlatny; //!!!

// Operations
public:
	CJednoduchyEditorDoc* GetDocument() const;

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

	void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	void OnLButtonDown(UINT nFlags, CPoint point); //!!!

// Implementation
public:
	virtual ~CJednoduchyEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in JednoduchyEditorView.cpp
inline CJednoduchyEditorDoc* CJednoduchyEditorView::GetDocument() const
   { return reinterpret_cast<CJednoduchyEditorDoc*>(m_pDocument); }
#endif

#endif
